﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;

namespace WFSTest
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            winformsMap1.MapUnit = GeographyUnit.Meter;
            WmsRasterLayer wmsfl = new WmsRasterLayer(new Uri("https://mesonet.agron.iastate.edu/cgi-bin/wms/us/mrms.cgi?VERSION=1.1.1"));

            wmsfl.SendingWebRequest += wmsfl_SendingWebRequest;

            wmsfl.Open();
            Collection<string> layers = wmsfl.GetServerLayerNames();
            Collection<string> styles = wmsfl.GetServerStyleNames();
            wmsfl.UpperThreshold = double.MaxValue;
            wmsfl.LowerThreshold = 0;
            wmsfl.TimeoutInSecond = 60;
            foreach (string layer in layers)
            {
                wmsfl.ActiveLayerNames.Add(layer);
            }
            foreach (string style in styles)
            {
                wmsfl.ActiveStyleNames.Add(style);
            }

            RectangleShape rect = wmsfl.GetBoundingBox();
            
            ManagedProj4Projection proj = new ManagedProj4Projection();

            proj.InternalProjectionParametersString = ManagedProj4Projection.GetEpsgParametersString(4326);
            proj.ExternalProjectionParametersString = ManagedProj4Projection.GetSphericalMercatorParametersString();

            proj.Open();
            //wmsfl.Crs = "EPSG:3857";
            wmsfl.ImageSource.Projection = proj;
            rect = proj.ConvertToExternalProjection(rect);

            //wmsfl.Close();

            LayerOverlay CultureOverlay = new LayerOverlay();
            CultureOverlay.Layers.Add(wmsfl);
            winformsMap1.Overlays.Add(CultureOverlay);
            winformsMap1.CurrentExtent = rect;
            winformsMap1.Refresh();

        }

        void wmsfl_SendingWebRequest(object sender, SendingWebRequestEventArgs e)
        {
            Debug.Print(e.WebRequest.RequestUri.AbsoluteUri);
        }
    }
}
